function sp = prova (knots)

  ndim = numel (knots);
  sp.knots   = knots;

  sp.spline_space = prova2 (sp.knots);

  sp.dofs = [];
  if (ndim > 1)
    for iside = 1:ndim
      ind = setdiff (1:ndim, iside);
      
      sp.boundary(iside) = prova (sp.knots(ind));
      sp.boundary(iside).dofs = ind;
% If I comment this line, sp.boundary.spline_space is an object of class prova2
% After this line, it becomes a struct
      sp.boundary(iside).spline_space.dofs = sp.boundary(iside).dofs;
    end
  else
    sp.boundary = [];
  end
  
  sp = class (sp, 'prova');
  
end
